Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoSpotLightManip Class Reference
[Manipulators]

`#include <Inventor/manips/SoSpotLightManip.h>`

Inheritance diagram for SoSpotLightManip:

List of all members.

## Detailed Description

The SoSpotLightManip class is used to manipulate spot light nodes.

A manipulator is used by replacing the node you want to edit in the graph with the manipulator. Draggers are used to to manipulate the node. When manipulation is finished, the node is put back into the graph, replacing the manipulator.

## Public Member Functions
| SoSpotLightManip (void)
SoDragger * | getDragger (void)
SbBool | replaceNode (SoPath *p)
SbBool | replaceManip (SoPath *p, SoSpotLight *newone) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual SoChildList * | getChildren (void) const
## Static Public Member Functions
void | initClass (void)
## Protected Member Functions
| ~SoSpotLightManip ()
void | setDragger (SoDragger *newdragger)
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
## Static Protected Member Functions
void | transferFieldValues (const SoSpotLight *from, SoSpotLight *to)
void | valueChangedCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *d)
## Protected Attributes
SoFieldSensor * | locationFieldSensor
SoFieldSensor * | directionFieldSensor
SoFieldSensor * | angleFieldSensor
SoFieldSensor * | colorFieldSensor
SoChildList * | children

## Constructor & Destructor Documentation

SoSpotLightManip::SoSpotLightManip | ( | void |  | ) |

| The constructor sets up the internal SoSpotLightDragger used for manipulation.

SoSpotLightManip::~SoSpotLightManip | ( |  | ) | `[protected]`

| Destructor.

## Member Function Documentation

void SoSpotLightManip::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoSpotLight.

SoDragger * SoSpotLightManip::getDragger | ( | void |  | ) |

| Returns pointer to internal dragger.

SbBool SoSpotLightManip::replaceNode | ( | SoPath * | path | ) |

| Replaces the node specified by path with this manipulator. The manipulator will copy the field data from the node, to make it affect the state in the same way as the node.

SbBool SoSpotLightManip::replaceManip | ( | SoPath * | path,
|  | SoSpotLight * | newone
| ) | const

| Replaces this manipulator from the position specified by path with newnode. If newnode is `NULL`, an SoSpotLight will be created for you.

void SoSpotLightManip::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoSpotLightManip::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoLight.

void SoSpotLightManip::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoSpotLight.

void SoSpotLightManip::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

| Action method for the SoGetBoundingBoxAction. Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node. Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables. Reimplemented from SoNode.

void SoSpotLightManip::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoNode.

void SoSpotLightManip::handleEvent | ( | SoHandleEventAction * | action | ) | `[virtual]`

| Action method for SoHandleEventAction. Inspects the event data from action, and processes it if it is something which this node should react to. Nodes influencing relevant state variables for how event handling is done also overrides this method. Reimplemented from SoNode.

void SoSpotLightManip::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoSpotLightManip::search | ( | SoSearchAction * | action | ) | `[virtual]`

| Action method for SoSearchAction. Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node. See also: SoSearchAction Reimplemented from SoNode.

SoChildList * SoSpotLightManip::getChildren | ( | void |  | ) | const`[virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Returns the children of this node. This node only has the dragger as a child. Reimplemented from SoNode.

void SoSpotLightManip::setDragger | ( | SoDragger * | newdragger | ) | `[protected]`

| Set dragger to use for user interaction.

void SoSpotLightManip::copyContents | ( | const SoFieldContainer * | fromfc,
|  | SbBool | copyconnections
| ) | `[protected, virtual]`

| Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`. This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically. Note that for simply copying e.g. a node from application code, it should be sufficient to do:
      SoNode * mynewnode = templatenode->copy();
Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:
      void
      MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                        SbBool copyconnections)
      {
        // let parent superclasses do their thing (copy fields, copy
        // instance name, etc etc)
        SoNode::copyContents(from, copyconnections);

        // [..then copy internal data..]
      }
Reimplemented from SoNode.

void SoSpotLightManip::transferFieldValues | ( | const SoSpotLight * | from,
|  | SoSpotLight * | to
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Copies field values.

void SoSpotLightManip::valueChangedCB | ( | void * | m,
|  | SoDragger * | dragger
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Updates the fields when the motion matrix changes.

void SoSpotLightManip::fieldSensorCB | ( | void * | m,
|  | SoSensor * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Updates the dragger whenever a field is modified.

## Member Data Documentation

SoFieldSensor * SoSpotLightManip::locationFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoSpotLightManip::directionFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoSpotLightManip::angleFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoSpotLightManip::colorFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoChildList * SoSpotLightManip::children`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoSpotLightManip.h
- SoSpotLightManip.cpp
- commoncode.cpp